import * as pb from 'protobufjs';
import { CMDOptions, EnumEntity, FunctionEntity, InterfaceEntity, InterfacePropertyEntity, PbNodeEntity, ServiceEntity } from '../interfaces';
export declare function loadPb(options: Partial<CMDOptions>, outConstMap: {
    [key: string]: number;
}): Promise<Map<string, PbNodeEntity[]>>;
export declare function convertMethodToFunctionEntity(node: pb.Method): FunctionEntity;
export declare function convertMessageToInterfaceEntity(node: pb.Type, options: Partial<CMDOptions>): InterfaceEntity;
export declare function convertToEnumEntity(node: pb.Enum): EnumEntity;
export declare function convertFieldToInterfacePropertyEntity(d: pb.Field, options: {
    i64_as_number?: boolean;
    mapType?: string;
}): InterfacePropertyEntity;
export declare function convertServiceToServiceEntity(data: pb.Service): ServiceEntity;
export declare function printServices(data: ServiceEntity[]): string;
export declare function isField(v: any): v is pb.Field;
export declare function crawlAstAndAttachNamespace(ast: pb.IParserResult, nodeMap: Map<string, PbNodeEntity[]>, outConstMap?: {
    [key: string]: number | string;
}): void;
export declare function isOriginType(type: string): boolean;
