"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.replaceTsHelperInt64 = exports.isUndefined = void 0;
const tslib_1 = require("tslib");
const fs = tslib_1.__importStar(require("fs-extra"));
function isUndefined(v) {
    return typeof v === 'undefined';
}
exports.isUndefined = isUndefined;
function replaceTsHelperInt64(filePath) {
    const strToReplace = `declare var Int64: {
    prototype: Int64;
    new (): Int64;
};
interface Int64 {
    toString(): string;
}
declare type ReqNumber = number | string | Int64;
declare type RespNumber = Int64;
declare type WrapperReqNumber<T> = Int64 extends T ? ReqNumber : T extends number[] ? ReqNumber[] : T;
declare type WrapperRespNumber<T> = T extends number ? RespNumber : T extends number[] ? RespNumber[] : T;`;
    const newStr = `declare type Int64 = string;
declare type ReqNumber = number | string | Int64;
declare type RespNumber = Int64;
declare type WrapperReqNumber<T> = T;
declare type WrapperRespNumber<T> = T;`;
    fs.writeFileSync(filePath, fs
        .readFileSync(filePath)
        .toString()
        .replace(strToReplace, newStr));
}
exports.replaceTsHelperInt64 = replaceTsHelperInt64;
